// Registernamen einbinden
#include <avr/io.h>

// Port-Konfiguration einbinden
#include "config.h"

// LCD-Ansteuerung einbinden
#include "lcd-routines.h"

// Fat-Dateisystem einbinden
#include "mmc.h"
#include "fat.h"

// Wartezeiten einbinden
#include <util/delay.h> // Darf nicht vor der Frequenzangabe in config.h aufgerufen werden!!!

// Interrupts einbinden
#include <avr/interrupt.h>

unsigned int pressed = 0;

// Hauptschleife 
int main (void) {

	// Tasten-port als Eingang definieren
	BUTTON_DDR = 0x00;
	// Interne PullUps fr Tastenport aktivieren
	BUTTON_PORT = 0xff;

	// LCD initialisieren
	lcd_init();
	
	lcd_msg("Hello!")

	// Interrupts aktivieren
	sei();

	//Initialisierung der MMC/SD-Karte
	lcd_msg("SUCHE SD-CARD");
	//Initialisierung der MMC/SD-Karte
	while ( mmc_init() !=0) //ist der Rckgabewert 	ungleich NULL ist ein Fehler aufgetreten
		{
		//	lcd_msg("SUCHE SD-CARD");
		}
	lcd_msg("SD GEFUNDEN");
	
	fat_cluster_data_store();//laden Cluster OFFSET und Size ins EEPROM
	//Initialisierung der MMC/SD-Karte ENDE!

	lcd_msg("TEST");

	unsigned int tmp;
	
/*	mmc_read_csd (Buffer);
	
	for (tmp = 0;tmp<16;tmp++)
		{
		lcd_msg(Buffer[tmp]);
		//usart_write("%x ",Buffer[tmp]);
		};
*/

	//Ausgabe des Root Directory
	unsigned int Clustervar;
	unsigned char Dir_Attrib = 0;
	unsigned long Size = 0;
	for (char a = 1;a < 240;a++)
	{
		Clustervar = fat_read_dir_ent(0,a,&Size,&Dir_Attrib,Buffer);
			if (Clustervar == 0xffff)
			{
				break;
			}
		tmp = (Size & 0x0000FFFF);
		lcd_msg(Buffer);
		//usart_write("Cluster = %4x DirA = %2x FileName = ",Clustervar,Dir_Attrib);
		//usart_write("%s",Buffer);
		//usart_write("\n");
	}

/*
	//Lade Cluster fr das index.htm File in den Speicher 
	Clustervar = 0;//suche im Root Verzeichnis
	if (fat_search_file("mmc.txt",&Clustervar,&Size,&Dir_Attrib,Buffer) == 1)
		{
		usart_write("\nFile Found!!\n\n");
		//Lese File und gibt es auf der seriellen Schnittstelle aus
		for (int b = 0;b<52;b++)
			{
			fat_read_file (Clustervar,Buffer,b);
			for (int a = 0;a<512;a++)
				{
				usart_write("%c",Buffer[a]);
				}
			}
		}
*/
	lcd_msg("HAUPTSCHLEIFE");

	// Hauptschleife starten
	for(;;) {
	}

	// Toter Code
	return 0;
}